'use strict';

var objectAssign = require('object-assign');

function handler(data,option){
  var _ret = [],
      _map = {},
      _moved = {},
      defaultOption = {
          id: 'id',
          parent: 'parentId',
          children: 'children'
      };

  option = objectAssign(defaultOption, option);

  data.forEach(function(e,i){
      _map[e[option.id]] = e;
  });

  for(var i in _map){
      var node = _map[i],
          p = node[option.parent];

      if(p && _map[p]){
          !_map[p][option.children] ? _map[p][option.children] = [node] : _map[p][option.children].push(node);
          _moved[i] = true
      }
  }

  for(var i in _map){
      var node = _map[i];
      if(!_moved[i]){
          _ret.push(node);
      }
  }

  return _ret;         
}

module.exports = handler;